#include<stdio.h>
#include<string.h>
#include<conio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include "..\lib\9188d.h"

//global v

unsigned base=0xE000;
unsigned offset=0;

void WriteToFlash(void){
int init,i;
unsigned dataoffset=0;
char *c2 ="@058";//initial to set Digital output ' @AA(data) '
int watchdog_t=0;//reset varible
unsigned char c0[60];
int reset_N=6;//reset condition
		printf("================================================================================\n");
		printf("===========================  Write 'FLASH' Memory  =============================\n");
		printf("================================================================================\n");
		srand(time(NULL));//give a random number to change output status 
		Init5DigitLed();
		FlashErase(base);//erase Flash memory to change data for 0 to 1
		printf("In this program that we change output status randomly. Output status changes\n");
		printf("from 0 ~ F. If output status change to ':'or';'or'<'or'='or'>'or'?'or'@'\n");
		printf("which we considered invalid then we can assign a invalid number and if valid number \n");
		printf("exceed limit then we enable watchdog timer to reset our system. And we\n");
		printf("also show out where data to be stored in Flash memory\n");
		printf("\n <note> this program will change 20 times and invalid times set to 5\n");
		for(i=0;i<20;i++){
			init=rand()%23+48;//init will vary from 0~F in ASCII table
			printf("\nthe random number is %c\n",init);
			if(init==58||init==59||init==60||init==61||
			   init==62||init==63||init==64) watchdog_t++;
			// if init equal to following number then watchdog_t+1
			// 58=>':' 59=>';' 60=>'<' 61=>'=' 62=>'>' 63=>'?' 64=>'@'  
			if(watchdog_t>reset_N){//if watchdog_t bigger than reset_N we enable WatchDog Timer to reset
				EnableWDT();
				RefreshWDT();
			} 
			c2[3]=init;
			FlashWrite(base,dataoffset,init);//write data to Flash memory
			printf("After write:%04X:%04X=%02X\n",base,dataoffset,FlashRead(base,dataoffset));
			dataoffset++;//increase dataoffset
			SendCmdTo9000(2,c2,0);//send command '@AA(data)' to read_9000
			DelayTimeMs(1000);	
		}

}

void WriteToEEPROM(void){
int init,i;
int EEP_address=0;
unsigned dataoffset=0;
char *c2 ="@058";//initial set Digital output ' @AA(data) '
int watchdog_t=0;//reset varible
int reset_N=6;//reset condition

		srand(time(NULL));//give a random number to change output status 
		Init5DigitLed();
		printf("In this program that we change output status randomly. Output status changes\n");
		printf("from 0 ~ F. If output status change to ':'or';'or'<'or'='or'>'or'?'or'@'\n");
		printf("which we considered invalid then we can assign a invalid number and if valid number \n");
		printf("exceed limit then we enable watchdog timer to reset our system. And we\n");
		printf("also show out where data to be stored in Flash memory\n");
		for(i=0;i<20;i++){
			init=rand()%23+48;//init will vary from 0~F in ASCII table
			printf("\nthe random number is %c\n",init);
			if(init==58||init==59||init==60||init==61||
			   init==62||init==63||init==64) watchdog_t++;
			// if init equal to following number then watchdog_t+1
			// 58=>':' 59=>';' 60=>'<' 61=>'=' 62=>'>' 63=>'?' 64=>'@'  
			if(watchdog_t>reset_N){//if watchdog_t bigger than reset_N we enable WatchDog Timer to reset
				EnableWDT();
				RefreshWDT();
			} 
			c2[3]=init;
				EnableEEP();
      				WriteEEP(EEP_address,i,init&0xff);//write data to EEPROM 
       				ProtectEEP();
			printf("\nRead EEPROM : address=%d data (%X) in block %d",i,ReadEEP(EEP_address,i),EEP_address);
			SendCmdTo9000(2,c2,0);//send command '@AA(data)' to read_9000
			DelayTimeMs(1000);	
		}

}

void  main()
{
int E_or_F;//variable for WriteEEPROM or WriteFlash

InstallCom(2,9600L,8,0,1);//initial com2	

Init5DigitLed();
printf("===============================================================================================\n");		
printf("In this demo we try to connect output signal to input signal that after change output status we\n");
printf("can stimulate output status as data to be stored in EEPROM or FLASH\n");
printf("===============================================================================================\n");
printf("If you want write data to EEPROM press '1'\n");
printf("If you want write data to FLASH press '2'\n");
scanf("\n%d",&E_or_F);

	if(E_or_F==1){
		WriteToEEPROM();//trying to write data to EEPROM
	}else{
		WriteToFlash();//trying to write data to FLASH
	}

}
