// TOPSCCC 9188 DEMO2
#include<stdio.h>
#include<conio.h>
#include "..\lib\9188d.h"

//global v
int q=0,w=0,e=0;

/* ------------------------------------------------------------------- */
void PerformTest(void){
int i1,i2,i3,j,value;
char c;

i1=i2=i3=0; j=0;
LedOn();	/* red-LED on      */

  while(1)
  {
    if (IsCom(1)==QueueIsNotEmpty) /* is COM1 receive any data ?		       */
    {			/* Yes, receive some data			    */
       value=ReadCom(1);	/* read one character from COM1 		    */
       ToCom(1,value);		/* send this character back to COM1		    */
				/* --> you will see this character in PC's monitor  */
       printf("\nCOM1 get %x", value);
       i1++; i1=i1&0x07; Show5DigitLed(1,i1);
       j++; j=j&0x01; if (j==0) LedOn(); else LedOff();
    }

    if (IsCom(2)==QueueIsNotEmpty) /* is COM2 receive any data ?		       */
    {			/* Yes, receive some data		    */
       value=ReadCom(2);	/* read one character from COM2 	    */
       printf("\nCOM2 get %x", value);

	Set485DirToTransmit(2);	/* change 485 direction to Transmit	    */
	ToCom(2,value);		/* send this character back to COM2	    */
				/* --> you will see this character in PC's monitor  */
	WaitTransmitOver(2);	/* wait this character transmit over	    */
	Set485DirToReceive(2);	/* change 485 direction to Receive	    */
	//Show5DigitLed(5,value-'0');

       i2++; i2=i2&0x07; Show5DigitLed(2,i2);
       j++; j=j&0x01; if (j==0) LedOn(); else LedOff();

    }

    if (IsCom(3)==QueueIsNotEmpty) /* is COM3 receive any data ?		       */
    {				/* Yes, receive some data			   */
       value=ReadCom(3);	/* read one character from COM3 		   */
       ToCom(3,value);		/* send this character back to COM3		   */
				/* --> you will see this character in PC's monitor */
       printf("\nCOM3 get %x", value);
       i3++; i3=i3&0x07; Show5DigitLed(3,i3);
       j++; j=j&0x01; if (j==0) LedOn(); else LedOff();
    }

    if (kbhit())		/* is user press PC's keyboard from COM4       */
    {
       c=getch();		/* if this key is Q or Q --> exit this program */
       if ((c=='q') || (c=='Q'))
       {
	  RestoreCom(1);
	  RestoreCom(2);
	  RestoreCom(3);
	  return;
	}

       if (c=='1'){
	ToCom(1,q);
	//Set485DirToTransmit(1);
	//ToCom(1,q);
	//WaitTransmitOver(1);
	//Set485DirToReceive(1);
	q++;
       }
       if (c=='2'){
	Set485DirToTransmit(2);
	ToCom(2,e);
	WaitTransmitOver(2);
	Set485DirToReceive(2);
	e++;
       }
       if (c=='3'){
	ToCom(3,w);
	w++;
       }

    }
  }

}
/************************************************************/
void  main()
{

InstallCom(1,57600L,8,0,1);	/* COM1, RS-232, full-duplex mode, INT	     */
				/*	 Note : JP1 must select RS-232	     */
InstallCom(2,57600L,8,0,1);	/* COM2, RS-485, half-duplex mode, INT	     */
				/*	 --> need to control 485 direction   */
				/*	 --> initial 485 direction = Receive */
InstallCom(3,57600L,8,0,1);	/* COM3, RS-232, full-duplex mode, INT	     */
/* COM4, RS-232, connect to PC's COM port for download */

Init5DigitLed();		/* initial & blank the 5-digit LED	      */

PerformTest();			/* RS232 and RS485 test */

}
