// TOPSCCC 9188 DEMO4
#include<stdio.h>
#include<conio.h>
#include "..\lib\9188d.h"

/* ------------------------------------------------------------------- */
void WriteToEEP(void){
  int i,j,ret;

  EnableEEP();			/* enable for write */

  printf("\nWrite EEPROM : ");
  for (j=0; j<7; j++){		/* write initial value to all 1K bytes data */
     printf("\nwriting block=%x\n",j);
     for (i=0; i<256; i++) {
	  ret=WriteEEP(j,i,(i+j)&0xff);
	  printf("\raddr=%2X,data=%2X ret=%d",i,(i+j)&0xff,ret);
     }
  }
  printf("\n");

  ProtectEEP();			/* protect data in EEPROM  */

}
/****************************************************************/
void  main()
{ int i,j,t,k;
  char c;

  Init5DigitLed();		/* 5-digit LED initial */

  WriteToEEP();                 /* Write some patterns to EEP */

  for (k=0;k<256;k++) {
    i++; i=i&0x01;
    if (i==0) LedOn();	else LedOff();

    printf("\nRead EEPROM : address=%d(%X) data in block 0-7=",k,k);
    for (j=0; j<7; j++) {
	t=ReadEEP(j,k);        /* read back EEPROM */
	printf("%02X ",t);
    }
    DelayTimeMs(300);		/* delay for 0.3 sec */

    while (kbhit() != 0) {
       c=getch();
       if ((c=='q')|| (c=='Q')) return;
       printf("(%c)",c);
    }
  }
}

