// TOPSCCC 9188 DEMO3
#include<stdio.h>
#include<stdlib.h>
#include<conio.h>
#include "..\lib\9188d.h"

/* ------------------------------------------------------------------- */
int data;

void TestNVRAM(void)
{
  unsigned int j=0;
  unsigned char NVRAM[31];

  /* read current NVRAM 0-31 */
  for(j=0;j<31;j++){ NVRAM[j]=ReadNVRAM(j); }
  printf("\nCurrent Values are:\n");
  for(j=0;j<31;j++) printf("%3d ",NVRAM[j]);
  for(j=0;j<31;j++) NVRAM[j]++;  		/* increment by 1 */
  printf("\nAll the values are added by 1");
  for (j=0;j<31; j++) WriteNVRAM(j,NVRAM[j]);  /* write to NVRAM for test */
  printf("\nAfter write Values are:\n");
  for(j=0;j<31;j++) printf("%3d ",ReadNVRAM(j));

}
/**********************************************************/
void ExeCommand(void){

  unsigned int j=0;
  int idx,regidx,quit;
  char c,cmd[20];

  quit=0;
  cmd[0]=0;
  idx=0;
  regidx=0;
  printf("\n Enter 's' for displaying all the NVRAM values");
  printf("\n Enter 'r[index]' for setting the index of NVRAM");
  printf("\n Enter a number for write a value");
  printf("\n Enter 'q' to quite");
  printf("\n>>");
  while(!quit){
    if(kbhit()){
       switch(c=getch()){
	 case 'q': case 'Q': quit=1;
	 case '\r':
	      putch('\r');
	      putch('\n');
	      cmd[idx]=0;
	      switch(cmd[0]){
	       case 's': case 'S': /* show all */
		    for(j=0;j<31;j++) printf("%3d ",ReadNVRAM(j));
		    break;
	       case 'r': case 'R': /* set register idx */
		    regidx=atoi(cmd+1);
		    printf("\nset idx to %d",regidx);
		    break;
	       default:
		    if(cmd[0]>='0' && cmd[0]<='9'){
		       /* set value to current register */
		       data=atoi(cmd);
		       WriteNVRAM(regidx,data);
		       printf("\nwrite %d to index %d",data,regidx);
		    }
	      }
	      idx=0;
	      printf("\n>>");
	      break;
	 case '\b':
	      if(idx){
		 cmd[--idx]=0;
		 putchar(c);
	      }
	      break;
	 default:
	      cmd[idx++]=c;
	      putchar(c);
	      break;
       }
    }
  }

}
/***********************************************************/
void  main()
{
  Init5DigitLed();		  /* 5-digit LED initial  */
  Show5DigitLed(3,17);		  /* show - in 5-digit LED */

  TestNVRAM();			  /* perform some basic test */
  ExeCommand();			  /* execute commands from users' input */
}
