// TOPSCCC 9188 DEMO9
/*
   Use UserTimer function to control LED on/off
*/
#include<stdio.h>
#include"..\lib\9188d.h"

/*
  After InstallUserTimer();
  UserFun will be called every 1ms.
*/

void UserFun(void)
{ static int count=0;
  static int Led=0;

  count++;
  if(count>=500){
     count=0;
     if(Led){
	LedOff();
	Led=0;
     }
     else {
	LedOn();
	Led=1;
     }
  }
}

void main(void)
{
  LedOff();
  TimerOpen();
  InstallUserTimer(UserFun);		//UserFun will be called every 1ms

  //press 'q' to quit
  while(1){
    if(kbhit4() && getch4()=='q') break;
  }

  TimerClose();
  LedOn();
}
